/*
 * DefaultGame.cpp
 *
 *  Created on: 22 Jun 2013
 *      Author: Ashley
 */

#include "DefaultGame.h"

float w2b(float f) {
	return f / InGameState::worldScale;
}

 MyButton::MyButton(): 
	ARK::UI::Button()
{ 

}
void MyButton::renderText(int x, int y) {
	
}
void MyButton::renderBackground() {

}
void MyButton::renderOverlay() {

}
void MyButton::render() {
	if (!visible){ return; }
	float x = round(transform.position.x);
	float y = round(transform.position.y);
	float ox = x;
	float oy = y;
	x += 1;
	y += 1;
	if (m_state == STATE_OVER) {
	} else if (m_state == STATE_DOWN) {
		x += 1;
		y += 1;
	}

	DefaultGame* dg = DefaultGame::getInstance();
	Renderer* r = ARK2D::getRenderer();

	r->setDrawColor("#333333", 1.0f);
	dg->buttonShadow->drawCentered(ox, oy);

	r->setDrawColor("#d3d2d2", 1.0f);
	dg->buttonSquare->drawCentered(ox, oy);

	r->setDrawColor(Color::white);
	dg->buttonSquare->drawCentered(x, y);
	
}
void MyButton::renderImage(int x, int y) {
}
MyButton::~MyButton() { }



MyIconButton::MyIconButton(): 
	MyButton(),
	iconImage(NULL)
{ 

}
void MyIconButton::render() {
	if (!visible){ return; }
	float x = round(transform.position.x);
	float y = round(transform.position.y);
	float ox = x;
	float oy = y;
	x += 0;
	y -= 3;
	if (m_state == STATE_OVER) {
	//	x += 0;
	//	y += 0;
	} else if (m_state == STATE_DOWN) {
		x += 0;
		y = oy;
	}

	DefaultGame* dg = DefaultGame::getInstance();
	Renderer* r = ARK2D::getRenderer();

	r->setDrawColor("#000000", 1.0f);
	dg->buttonShadow->drawCentered(ox, oy);

	r->setDrawColor("#d3d2d2", 1.0f);
	dg->buttonSquare->drawCentered(ox, oy);

	r->setDrawColor(Color::white);
	dg->buttonSquare->drawCentered(x, y);
}
MyIconButton::~MyIconButton() { }



DefaultGame::DefaultGame(string title): StateBasedGame(title) {

}

void DefaultGame::initStates(GameContainer* container) {
	
	// load! yay
	/*stateLoading = new MyLoadingState(this);
	addState(stateLoading); 
	setCurrentState(stateLoading);
	ARK2D::getContainer()->getTimer()->flush();
	enterState(stateLoading);  */

	//container->scene->setBatching(false);

	Renderer::setInterpolation(Renderer::INTERPOLATION_NEAREST);
//	Renderer::setInterpolation(Renderer::INTERPOLATION_LINEAR);

	Renderer* r = ARK2D::getRenderer();
	r->setScissorBoxColors(Color::black,Color::black,Color::black,Color::black);
	
	sheet = Resource::get("art.png")->asImage();
	desc = Resource::get("art.spritesheetdescription")->asSpriteSheetDescription();

	//background = (Image*) spritesheet->getSubImage(desc->getItemByName("new/houndstooth.png"))->scale(0.5f, 0.5f);

	//buttonShadow = (Image*) spritesheet->getSubImage(desc->getItemByName("new/tile-base.png"));
	//buttonSquare = (Image*) spritesheet->getSubImage(desc->getItemByName("new/tile.png"));

	//Renderer::setInterpolation(Renderer::INTERPOLATION_LINEAR);
	//titlefont = Resource::get("fonts/title.fnt")->asFont()->asBMFont();
	//font = Resource::get("fonts/numbers.fnt")->asFont()->asBMFont();

	m_music = Resource::get("music.ogg")->asSound();

	sfx_menu_select = Resource::get("sfx/menu-select.wav")->asSound();
	sfx_menu_change = Resource::get("sfx/menu-change.wav")->asSound();
	sfx_menu_back = Resource::get("sfx/menu-back.wav")->asSound();
	sfx_die = Resource::get("sfx/die.wav")->asSound(); 
	sfx_win = Resource::get("sfx/win.wav")->asSound();

	sfx_suck = Resource::get("sfx/suck2.wav")->asSound();
	sfx_levelUp = Resource::get("sfx/level-up.wav")->asSound();

	Sound* s = NULL;
	s = Resource::get("sfx/item1.wav")->asSound(); sfx_items.push_back(s);
	s = Resource::get("sfx/item2.wav")->asSound(); sfx_items.push_back(s);
	s = Resource::get("sfx/item3.wav")->asSound(); sfx_items.push_back(s);
	s = Resource::get("sfx/item4.wav")->asSound(); sfx_items.push_back(s);
	s = Resource::get("sfx/item5.wav")->asSound(); sfx_items.push_back(s);
	for(unsigned int i = 0; i < sfx_items.size(); i++) {
		sfx_items[i]->setVolume(0.25f);
	}

	//container->setSize(160*4, 240*4);

	stateLoading = NULL;
	stateBlank = new BlankState();
	stateSplash = new SplashState(); // fail state.
	stateMenu = new MenuState();
	stateInGame = new InGameState();
	addState(stateBlank);
	addState(stateSplash);
	addState(stateMenu);
	addState(stateInGame);
	//setCurrentState(stateInGame);
	setCurrentState(stateMenu);
	//setCurrentState(stateInGame);
	//setCurrentState(stateSplash);
}

void DefaultGame::load() {

	/*stateBlank = new BlankState();
	stateSplash = new SplashState(); 
	stateMenu = new MenuState(); 
	stateInstructions = new InstructionsState();
	stateInGame = new InGameState();  
	stateSummary = new SummaryState(); 

	spritesheet = NULL;
	desc = NULL;
	stateLoading->m_itemsAt++;

	m_music = NULL;
	stateLoading->m_itemsAt++;

	addState(stateBlank);
	addState(stateSplash); 
	addState(stateMenu);
	addState(stateInstructions);
	addState(stateInGame);
	addState(stateSummary);
	setCurrentState(stateLoading);

	stateLoading->m_nextState = stateInGame; 

	vector<GameState*> states = getStates();
	for(unsigned int i = 0; i < states.size(); i++) {
		GameState* s = states.at(i);
		if (s != stateLoading) {
			ARK2D::getLog()->i("Initting a state");
			s->init(ARK2D::getContainer(), this);
		}
	} 

	*/
}

void DefaultGame::update(GameContainer* container, GameTimer* timer) {
	StateBasedGame::update(container, timer);

	Input* i = ARK2D::getInput();
	if (i->isGamepadButtonPressed(Gamepad::BUTTON_ACTIVATE) || i->isKeyPressed(Input::KEY_F)) {
		container->setFullscreen(!container->isFullscreen());
	}  
	
	//if (stateLoading != NULL && stateLoading->m_doneLoading) {
		if (i->isKeyPressed(Input::KEY_M)) {
			float newVol = (SoundStore::getInstance()->getVolumeByGroupId(0)==1.0f)?0.0f:1.0f;
			SoundStore::getInstance()->setVolumeByGroupId(0, newVol);
		}
		 
		if (m_music != NULL && !m_music->isPlaying()) {
			m_music->play();
		}
		
	//} 

	if (i->isKeyPressed(Input::MOUSE_BUTTON_LEFT)) {
		//ARK2D::getLog()->setVisible(!ARK2D::getLog()->isVisible());
		//ARK2D::getLog()->e(scene->getRoot()->toListString());
	}
}
 
void DefaultGame::render() {
	Renderer* r = ARK2D::getRenderer();
	//r->setDrawColorf(0.12f, 0.12f, 0.12f, 1.0f);
//	background->draw(0, 0);
	//r->setDrawColor(Color::white);

	StateBasedGame::render();
	//ARK2D::getLog()->e("render");

	//Camera::current->setClipping(0.0f, 1.0f);
	//ARK2D::getLog()->e( Camera::current->toString() );

	//Renderer* r = ARK2D::getRenderer();
	//r->setDrawColor(Color::white);
	//r->fillRect(-100,-100,200,200);
}

void DefaultGame::resize(GameContainer* container, int width, int height) {
	StateBasedGame::resize(container, width, height);

	//DisplayUtil::resize320x480(container, width, height);	
}

DefaultGame* DefaultGame::getInstance() {
    return dynamic_cast<DefaultGame*>(ARK2D::getGame());
}

DefaultGame::~DefaultGame() {

}
