/*
 * DefaultGame.h
 *
 *  Created on: 22 Jun 2013
 *      Author: Ashley
 */

#ifndef DEFAULTGAME_H_
#define DEFAULTGAME_H_

#include "ARK.h"

#include "states/BlankState.h"
#include "states/MyLoadingState.h"
#include "states/SplashState.h"
#include "states/MenuState.h"
#include "states/InstructionsState.h"
#include "states/InGameState.h" 
#include "states/SummaryState.h" 

#include <Box2D/Box2D.h> 

 float w2b(float f);

class StatesList {
	public:

		static const unsigned int STATE_BLANK = 0;
		static const unsigned int STATE_LOADING = 1;
		static const unsigned int STATE_SPLASH = 2;
		static const unsigned int STATE_MENU = 3;
		static const unsigned int STATE_INSTRUCTIONS = 4;
		static const unsigned int STATE_INGAME = 5;
		static const unsigned int STATE_SUMMARY = 6; 
};
class MyButton : public ARK::UI::Button {
	public:
		MyButton();
		virtual void render();
		virtual void renderBackground();
		virtual void renderText(int x, int y);
		virtual void renderOverlay();
		virtual void renderImage(int x, int y);
		virtual ~MyButton();
};
class MyIconButton : public MyButton {
	public:
		Image* iconImage;
		MyIconButton();
		virtual void render();
		virtual ~MyIconButton();
};


class DefaultGame : public StateBasedGame {
	public:

		BlankState* stateBlank;
		MyLoadingState* stateLoading;
		SplashState* stateSplash; 
		MenuState* stateMenu;  
		InstructionsState* stateInstructions;
		InGameState* stateInGame;
		SummaryState* stateSummary;

		Image* sheet;
		SpriteSheetDescription* desc;

		Image* background;
		ARK::Font::BMFont* font;
		ARK::Font::BMFont* titlefont;

		Image* buttonShadow;
		Image* buttonSquare;

		Sound* m_music;

		Sound* sfx_menu_select;
		Sound* sfx_menu_change;
		Sound* sfx_menu_back;
		Sound* sfx_die;
		Sound* sfx_win;
		Sound* sfx_suck;
		Sound* sfx_levelUp;
		vector<Sound*> sfx_items;

		DefaultGame(string title);
		virtual void initStates(GameContainer* container);
		virtual void load();
		virtual void update(GameContainer* container, GameTimer* timer);
		virtual void render();
		virtual void resize(GameContainer* container, int width, int height);
		virtual ~DefaultGame();

		static DefaultGame* getInstance();
};

#endif /* DEFAULTGAME_H_ */
