/*
 * MyParticle.cpp
 *
 *  Created on: 29 Jan 2011
 *      Author: Ashley
 */

#include "MyParticle.h"
#include "Player.h"
#include "../DefaultGame.h"
  

MyParticle::MyParticle():
	GameObject()
	
	{

	DefaultGame* dg = DefaultGame::getInstance(); 

	//m_bounds = new ARK::Geometry::Rectangle(0, 0, 30, 30);
	//m_bounds->setLocationByCenter(240, -50);
 
	//m_velocity->set(0, 0); 
	//m_velocityMax->set(250, 200);  
	//m_acceleration->set(400, 600);



} 
  
void MyParticle::reset() {  
	type = 0;
	timer = 0.0f;
	duration = 1.0f;
	position.m_x = 0;
	position.m_y = 0;
	velocity.m_x = 0;
	velocity.m_y = 0;
}  

void MyParticle::update(GameContainer* container, GameTimer* t) 
{
	DefaultGame* dg = DefaultGame::getInstance();

	float angle = MathUtil::anglef(0.0f, 0.0f, velocity.m_x, velocity.m_y);
	float dist = MathUtil::distance(0.0f, 0.0f, velocity.m_x, velocity.m_y);
	MathUtil::moveAngle<float>(&position, angle, dist * t->getDelta());

	if (type == 1) {
		// move towards player nozzle.
		float angle = MathUtil::anglef(
			position.m_x, 
			position.m_y, 
			dg->stateInGame->player->nozzle->GetPosition().x*InGameState::worldScale, 
			dg->stateInGame->player->nozzle->GetPosition().y*InGameState::worldScale
		);
		velocity.set(0, 0);
		MathUtil::moveAngle<float>(&velocity, angle, dist+t->getDelta());

	}

	timer += t->getDelta();
	if (timer >= duration)  {
		setPendingRemoval(true);
	}
}

void MyParticle::render(GameContainer* container, Renderer* r) {
	float alpha = Easing::easebetween(Easing::QUADRATIC_OUT, timer, 1.0f, 0.0f, duration);
	image->setAlpha(alpha);
	image->drawCentered(position.m_x, position.m_y);
}

MyParticle::~MyParticle() { 
	 
}
