/*
 * Object.cpp
 *
 *  Created on: 18 April 2012
 *      Author: Ashley
 */

#include "Object.h"
#include "../DefaultGame.h"

float Object::s_gravity = 225.0f; 

Object::Object(): 
	GameObject(), 
	m_bounds(NULL) 
	{
	m_velocity = new Vector2<float>(0,0);
	m_velocityMax = new Vector2<float>(0,0);
	m_acceleration = new Vector2<float>(0,0);
}

void Object::update(GameContainer* container, GameTimer* timer) {
	

} 

void Object::teleport() {
	m_bounds->setLocationByCenter( 
		MathUtil::randBetweenf(30.0f, ARK2D::getContainer()->getWidth() - 30.0f),
		MathUtil::randBetweenf(70.0f, ARK2D::getContainer()->getHeight() - 70.0f)
	); 
	keepInBounds();
} 

void Object::render(GameContainer* container, Renderer* r) {
	if (ARK2D::isDebug() && m_bounds != NULL) { 
		m_bounds->render(); 
	}
}
  
bool Object::keepInBounds() 
{
	GameContainer* container = ARK2D::getContainer();
	ARK::Geometry::Rectangle* bounds = m_bounds->asRectangle();
	
	// Keep in bounds.
	bool b = false;
	if (bounds->getMinX() < 58) {
		b = true;
		bounds->setX(58); 
		//m_velocity->setX(m_velocity->getX() * -1);
	} else if (bounds->getMaxX() > container->getWidth() - 58) {
		b = true;
		bounds->setX(container->getWidth() - bounds->getWidth() - 58);
		//m_velocity->setX(m_velocity->getX() * -1);
	}
	if (bounds->getMinY() < 58) {
		b = true; 
		bounds->setY(58); 
		//m_velocity->setY(m_velocity->getY() * -1);
	} else if (bounds->getMaxY() > container->getHeight() - 58) {  
		b = true; 
		bounds->setY(container->getHeight() - bounds->getHeight() - 58); 
		//m_velocity->setY(m_velocity->getY() * -1);
	}
	return b; 
}
void Object::gravity() {
	gravity(1.0f); 
}
void Object::gravity(float multiplier) {
	// Add Gravity 
	GameTimer* timer = ARK2D::getContainer()->getTimer();
	//if (!DefaultGame::getInstance()->stateInGame->isCoffeeMode()) {
		m_velocity->add(0, s_gravity * timer->getDelta()); 
	//}
	 
	m_velocity->restrictMax(m_velocityMax);
}

void Object::move(float multiplier = 1) {
	GameTimer* timer = ARK2D::getContainer()->getTimer();
	ARK::Geometry::Rectangle* bounds = m_bounds->asRectangle();
	bounds->adjustX(m_velocity->getX() * multiplier * timer->getDelta());
	bounds->adjustY(m_velocity->getY() * multiplier * timer->getDelta());
}

Object::~Object() {
	delete m_velocity;
	delete m_velocityMax;
}
