/*
 * Player.h
 *
 *  Created on: 29 Jan 2011
 *      Author: Ashley
 */

#ifndef PLAYER_H_
#define PLAYER_H_

#include "../ARK.h"
#include "Object.h" 
#include <Box2D/Box2D.h>

class Player : public Object { 
	public: 
		b2Body* dynamicBody;
        vector<b2Body*> nozzles;
        b2Body* nozzle;

		Image* playerImage;
        Image* nozzleImage;

        ARK::Geometry::Circle<float> nozzleBounds;

        float particleTimer;
        vector<float> suckedItemTimers;

		Player(b2World* world);
		float getX(); 
		void reset();
		virtual void update(GameContainer* container, GameTimer* timer);
		virtual void render(GameContainer* container, Renderer* r);
		virtual void collision(Object* other);
		virtual ~Player();
};

#endif /* PLAYER_H_ */
