/*
 * RoomObject.cpp
 *
 *  Created on: 29 Jan 2011
 *      Author: Ashley
 */

#include "RoomObject.h"
#include "../DefaultGame.h"

#include "Player.h"

RoomObject::RoomObject():
dynamicBody(NULL)
	
	{

		scaleTimer = 0.0f;
		scaleDuration = 0.5f;
//	DefaultGame* dg = DefaultGame::getInstance(); 

	//m_bounds = new ARK::Geometry::Rectangle(0, 0, 30, 30);
	//m_bounds->setLocationByCenter(240, -50);
 
	//m_velocity->set(0, 0); 
	//m_velocityMax->set(250, 200);  
	//m_acceleration->set(400, 600);



} 

void RoomObject::set(Image* image, float x, float y) {
	this->image = image;

	DefaultGame* dg = DefaultGame::getInstance();
	if (dynamicBody != NULL) {
		dg->stateInGame->world->DestroyBody(dynamicBody);
		dynamicBody = NULL;
	}

	radius = (image->getWidth() + image->getHeight()) * 0.5f;

	// create a thing that moves -- player
	b2BodyDef bodyDef;
	bodyDef.type = b2_dynamicBody;
	bodyDef.position.Set(w2b(x), w2b(y));
	dynamicBody = dg->stateInGame->world->CreateBody(&bodyDef);

	b2PolygonShape dynamicBox;
	dynamicBox.SetAsBox(w2b(image->getWidth()*0.5f), w2b(image->getHeight()*0.5f));

	b2FixtureDef fixtureDef;
	fixtureDef.shape = &dynamicBox;
	fixtureDef.density = 100.0f;
	fixtureDef.friction = 0.3f;
	dynamicBody->CreateFixture(&fixtureDef);

} 
  
void RoomObject::reset() {  
	//m_bounds->setLocationByCenter(MathUtil::randBetweenf(100.0f, 380.0f), -50.0f);
}  

void RoomObject::update() {

	if (scaleTimer > 0.0f) {
		InGameState* igs = DefaultGame::getInstance()->stateInGame;
		float dirx, diry = 0;
        float angle = MathUtil::anglef(
        	dynamicBody->GetPosition().x,//* InGameState::worldScale, 
        	dynamicBody->GetPosition().y,//* InGameState::worldScale, 
        	igs->player->nozzle->GetPosition().x,//* InGameState::worldScale,
        	igs->player->nozzle->GetPosition().y//,//* InGameState::worldScale
        );
		MathUtil::moveAngle<float>(dirx, diry, angle, 4.0f);
		dynamicBody->ApplyLinearImpulse( b2Vec2(dirx, diry), dynamicBody->GetWorldCenter(), false);
	}

	//InGameState* igs = DefaultGame::getInstance()->stateInGame;

	//m_bounds->asRectangle()->setY(m_bounds->getMinY() + (igs->m_speed * 0.5f * timer->getDelta()));

	//m_animation->update(timer);

	//if (m_bounds->getMinY() - igs->m_cameraY > 900) {
	//	setPendingRemoval(true);
	//}
}

void RoomObject::render() {
	b2Vec2 pos = dynamicBody->GetPosition();
	float angle = dynamicBody->GetAngle();
	//r->drawRect(pos.x, pos.y, 10, 10);

	float scale = 1.0f;
	if (scaleTimer > 0.0f) {
		scale = Easing::easebetween(Easing::QUADRATIC_OUT, scaleTimer, 1.0f, 0.0f, scaleDuration);
	}
	image->setDirty(true);
	image->setRotation(MathUtil::toDegrees(angle));
	image->drawCenteredScaled(pos.x*InGameState::worldScale, pos.y*InGameState::worldScale, scale, scale);

	if (DefaultGame::getInstance()->stateInGame->debug) {
		Renderer* r = ARK2D::getRenderer();
		r->drawCircle(pos.x*InGameState::worldScale, pos.y*InGameState::worldScale, radius, 20);
	}
	
	//r->setDrawColor(Color::green);
	//r->fillRect(m_bounds->getMinX(), m_bounds->getMinY(), m_bounds->getWidth(), m_bounds->getHeight());

	//s_image->drawCentered(m_bounds->getCenterX(), m_bounds->getCenterY());
	//m_animation->getCurrentFrame()->drawCentered(m_bounds->getCenterX(), m_bounds->getCenterY());
}

RoomObject::~RoomObject() { 
	 
}
