/*
 * InGameState.h
 * 08 Jun 2011
 */

#ifndef INGAMESTATE_H_
#define INGAMESTATE_H_

#include "../ARK.h"

#include <Box2D/Box2D.h>

class DefaultGame;

class Object;
class BlankObject;
class Player;
class Pickup;
class Explosion;
class RoomObject;
class ShelfObject;
class DecorationObject;
class MyParticle;


class InGameState : public GameState {
	public:

		Player* player;
		//Pool<Pickup* >* m_pickups;
		//Pool<Explosion* >* m_explosions;
		static const float worldScale = 80.0f; // 1m is 80 pixels.
		float worldWidth;
        b2World* world;
        b2Body* groundBody;

        vector<RoomObject*> roomObjects;
        vector<ShelfObject*> shelfObjects;
        vector<DecorationObject*> decorationObjects;
        
        Pool<MyParticle*>* particles;
        Image* particle;
        
        Image* backgroundImage;
        bool debug;

        float cameraX;

        unsigned int level;
        float levelTimer;
        float levelDuration; 
        unsigned int levelObjectCount;
        unsigned int levelObjectDoneCount;
        Image* levelTimerImageFull;
        Image* levelTimerImageEmpty;

        unsigned int score;

        float m_rotationEffectHappeningTimer;
		float m_rotationEffectHappeningDuration;
		bool m_rotationEffectHalfWayEvent;
		
		float m_rotationEffectTranslatePointStartX;
		float m_rotationEffectTranslatePointStartY;
		float m_rotationEffectTranslatePointX;
		float m_rotationEffectTranslatePointY;
		float m_rotationEffectAlpha;

		InGameState();
		void enter(GameContainer* container, StateBasedGame* game, GameState* from);
		void leave(GameContainer* container, StateBasedGame* game, GameState* to);

		unsigned int id();
		void reset();
		void start();
		void startLevel(unsigned int i);
		void init(GameContainer* container, StateBasedGame* game);
		void update(GameContainer* container, StateBasedGame* game, GameTimer* timer);
		void render(GameContainer* container, StateBasedGame* game, Renderer* r);

		

		virtual ~InGameState();
};

#endif /* INGAMESTATE_H_ */
