/*
 * MenuState.cpp
 *
 *  Created on: 08 Jun 2011
 *      Author: Ashley
 */

#include "MenuState.h"
#include "../DefaultGame.h"

MenuState::MenuState(): GameState() {

}

unsigned int MenuState::id() {
	return StatesList::STATE_MENU;
}

void MenuState::enter(GameContainer* container, StateBasedGame* game, GameState* from) { }
void MenuState::leave(GameContainer* container, StateBasedGame* game, GameState* to) { }

void MenuState::init(GameContainer* container, StateBasedGame* game) {

	DefaultGame* dg = DefaultGame::getInstance();
	m_selectedIndex = 0;

	logo = (Image*) dg->sheet->getSubImage(dg->desc->getItemByName("logo.png"))->scale(2.0f, 2.0f);

}

void MenuState::update(GameContainer* container, StateBasedGame* game, GameTimer* timer) {
	DefaultGame* dg = DefaultGame::getInstance();
	Input* i = ARK2D::getInput();

	if (i->isKeyPressed(Input::KEY_W) || i->isKeyPressed(Input::KEY_UP) || i->isGamepadButtonPressed(Gamepad::DPAD_UP)) {
		//dg->sfx_ui_move->play();
		m_selectedIndex--; 
		if (m_selectedIndex < MENU_BEGIN) {
			m_selectedIndex = MENU_END; 
		}
		dg->sfx_menu_change->play();
	}
	if (i->isKeyPressed(Input::KEY_S) || i->isKeyPressed(Input::KEY_DOWN) || i->isGamepadButtonPressed(Gamepad::DPAD_DOWN)) {
		//dg->sfx_ui_move->play();
		m_selectedIndex++;
		if (m_selectedIndex > MENU_END) {
			m_selectedIndex = MENU_BEGIN;
		}
		dg->sfx_menu_change->play();
	}

 
	if (i->isKeyPressed(Input::KEY_ENTER) || i->isGamepadButtonPressed(Gamepad::BUTTON_START) || i->isGamepadButtonPressed(Gamepad::BUTTON_A)) {
		//dg->sfx_ui_select->play();
		if (m_selectedIndex == MENU_PLAY) {
			//DefaultGame::getInstance()->m_sfxStart->play(); 
			dg->sfx_menu_select->play();
			dg->stateInGame->reset();
			dg->stateInGame->start(); 
			game->enterState(dg->stateInGame);

		} else if (m_selectedIndex == MENU_INSTRUCTIONS) {
			game->enterState(dg->stateInstructions);
		} //else if (m_selectedIndex == MENU_CREDITS) {
		//	game->enterState(dg->stateCredits, new FadeToColourTransition(0.5f,dg->m_darkerGrey), new FadeFromColourTransition(0.5f, dg->m_darkerGrey));
		//} 
		else if (m_selectedIndex == MENU_EXIT) {
			//dg->sfx_ui_select->stop();
			container->close();
		}
	} 
}

void MenuState::render(GameContainer* container, StateBasedGame* game, Renderer* r) {
	DefaultGame* dg = DefaultGame::getInstance();
	InGameState* igs = dg->stateInGame;
	//r->drawString("Menu", 20, 20, Renderer::ALIGN_LEFT, Renderer::ALIGN_TOP);
 
	container->setClearColor(Color("#222a3f"));

	r->setDrawColor(Color::white);

	logo->drawCentered(240, 100);
	
	int rooty = 200;
	int wid = (signed int) container->getWidth();

	r->drawString("@forcehabit", 240, 280, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);

	if (m_selectedIndex == MENU_PLAY) {
		r->drawString("< Play >", wid/2, rooty, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);
	} else {
		r->drawString("Play", wid/2, rooty, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);
	}

	if (m_selectedIndex == MENU_EXIT) { 
		r->drawString("< Exit >", wid/2, rooty+30, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);
	} else {
		r->drawString("Exit", wid/2, rooty+30, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);
	}
 
 	
}

MenuState::~MenuState() {

}