/*
 * SplashState.cpp
 *
 *  Created on: 08 Jun 2011
 *      Author: Ashley
 */

#include "../ARK.h"
#include "SplashState.h"

#include "../DefaultGame.h"

SplashState::SplashState():
	GameState() {

}

unsigned int SplashState::id() {
	return StatesList::STATE_BLANK;
}

void SplashState::enter(GameContainer* container, StateBasedGame* game, GameState* from) {
	
}
void SplashState::leave(GameContainer* container, StateBasedGame* game, GameState* to) {

}

void SplashState::init(GameContainer* container, StateBasedGame* game) {
	
	//ARK2D::getRenderer()->setDrawColor(Color::white);
	//ARK2D::getRenderer()->setInterpolation(Renderer::INTERPOLATION_NEAREST);

    DefaultGame* dg = DefaultGame::getInstance();
	failtext = (Image*) dg->sheet->getSubImage(dg->desc->getItemByName("fail.png"))->scale(2.0f, 2.0f);
	failtext->setCenterOfRotation(failtext->getWidth()*0.5f, failtext->getHeight()*0.5f);

}

void SplashState::update(GameContainer* container, StateBasedGame* game, GameTimer* timer) {
	DefaultGame* dg = DefaultGame::getInstance();
	Input* i = ARK2D::getInput();
	if (i->isKeyPressed(Input::KEY_ENTER) || i->isGamepadButtonPressed(Gamepad::BUTTON_START) || i->isGamepadButtonPressed(Gamepad::BUTTON_A)) {
		dg->sfx_menu_select->play();
		game->enterState(dg->stateMenu);
	}
} 


void SplashState::render(GameContainer* container, StateBasedGame* game, Renderer* r) {
	//container->setClearColor(Color::black_0a);

	//r->setDrawColor(Color::white);
	//ARK2D::getRenderer()->setInterpolation(Renderer::INTERPOLATION_NEAREST);
	
	failtext->drawCentered(240, 100);

    DefaultGame* dg = DefaultGame::getInstance();
	r->setDrawColor(Color::white);
    
	r->drawString(StringUtil::append("SCORE: ", StringUtil::zeropad(dg->stateInGame->score, 5)), 240, 190, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);
	r->drawString("< RETURN TO MENU >", 240, 220, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);

}  


 
SplashState::~SplashState() {

}

